function a = read_data_binary(filename)
% read binary data captured from microphones and returns array 

% check if cached filename exist
[filepath,name,ext] = fileparts(filename);

if (exist([filepath '\' name '.mat'],'file') == 2)
    disp('read_data_binary: reading data from matlab native cache file');
    ai16 = load([filepath '\' name ]);
    a = ai16.a;
else
    
    % open file
    f = fopen(filename, 'rb');

    % read file to matlab
    [ab cnt] = fread(f,'uint');

    %close file
    fclose(f);

    % alloc memory
    a = zeros(length(ab),31);

    % extract bits
    for i = 1:length(ab)
        a(i,1) = bitget(ab(i), 1);
        a(i,2) = bitget(ab(i), 2);
        a(i,3) = bitget(ab(i), 3);
        a(i,4) = bitget(ab(i), 4);
        a(i,5) = bitget(ab(i), 5);
        a(i,6) = bitget(ab(i), 6);
        a(i,7) = bitget(ab(i), 7);
        a(i,8) = bitget(ab(i), 8);

        a(i,9) = bitget(ab(i), 9);
        a(i,10) = bitget(ab(i), 10);
        a(i,11) = bitget(ab(i), 11);
        a(i,12) = bitget(ab(i), 12);
        a(i,13) = bitget(ab(i), 13);
        a(i,14) = bitget(ab(i), 14);
        a(i,15) = bitget(ab(i), 15);
        a(i,16) = bitget(ab(i), 16);

        a(i,17) = bitget(ab(i), 17);
        a(i,18) = bitget(ab(i), 18);
        a(i,19) = bitget(ab(i), 19);
        a(i,20) = bitget(ab(i), 20);
        a(i,21) = bitget(ab(i), 21);
        a(i,22) = bitget(ab(i), 22);
        a(i,23) = bitget(ab(i), 23);
        a(i,24) = bitget(ab(i), 24);
        
        a(i,25) = bitget(ab(i), 25);
        a(i,26) = bitget(ab(i), 26);
        a(i,27) = bitget(ab(i), 27);
        a(i,28) = bitget(ab(i), 28);
        a(i,29) = bitget(ab(i), 29);
        a(i,30) = bitget(ab(i), 30);
        a(i,31) = bitget(ab(i), 31);
        a(i,32) = bitget(ab(i), 32);
    end

    disp('read_data_binary: Creating cached data file in Matlab native format');
    fname = [filepath '\' name];
    save(fname,'a','-v7.3');
    disp('Done');
end


