function [pcm]= show_evboard_waveforms_b(filename,params)
% returns pcm samples for each microphone
% inputs:
% filename - name of file captured by capture_multichirp in binary format
% params - structure of measurement parameters

close all

%contains mic recodings and chirp and mic_en
mic_array_raw_data = read_data_binary(filename);  %read mic data from file once parsed from filename it 
                                                  % stores data in .mat
                                                  % file for faster load
                                                  % next time

%extract mic recordings 
mic_range = 1:31;%1:size(params.ao,2);                               % microphone indices
mic_array = mic_array_raw_data(:,mic_range);    % raw mic data for all microphones to mic_array


% Parameters for decimation
Fs = params.clk/params.dec;                 % pcm Fs
len = size(mic_array,1)/params.cnt;         % lenght of one chirp in PDM domain
pcm_len = floor(len/params.dec);            % length of one chirp in PCM samples (decimated)

mic_array_pcm = zeros(pcm_len,size(params.ao,2)); % output array allocation
chirp = zeros(pcm_len);                         % chirp signal allocation

for lj = mic_range
    pdm_chirp = mic_array(1:len,lj);
    pdm_chirp_trunc = pdm_chirp(1:pcm_len*params.dec);
    mic_array_pcm(:,lj) = cic_f(2.*pdm_chirp_trunc-1,params.dec);
end

pcm = mic_array_pcm;

for lj = mic_range
   figure, hold on, plot(mic_array_pcm(:,lj)), ylim([-800 800])
end




